#include <cmath>
#include <cstdlib>
#include <g2.h>
#include <g2_PS.h>
#include <g2_X11.h>
#include "fractale.h"
#include <fstream>
#include <iostream>
#include <string>


using namespace std;

void dessinerPanier(type_point p1,type_point p2,type_point p3,int level) 
{ 
    //cout << "dessiner panier " << level << endl;
    if (level==1) 
        dessinerTriangle(p1,p2,p3); 
    else { 
        level = level - 1; 
        //cout << "changement " << level << endl;
        dessinerPanier(p1, milieu(p1,p2), milieu(p1,p3), level); 
        dessinerPanier(milieu(p2,p1), p2, milieu(p2,p3), level); 
        dessinerPanier(milieu(p3,p1), milieu(p3,p2), p3, level); 
    } 
    return;
} 

void dessinerTriangle(type_point p1, type_point p2, type_point p3) 
{
    //g2_line(pdID, p1.abscisse, p1.ordonnee, p2.abscisse, p2.ordonnee);
    //g2_line(pdID, p1.abscisse, p1.ordonnee, p3.abscisse, p3.ordonnee);
    //g2_line(pdID, p3.abscisse, p3.ordonnee, p2.abscisse, p2.ordonnee);
    g2_filled_triangle(pdID, p1.abscisse, p1.ordonnee,
                             p2.abscisse, p2.ordonnee,
                             p3.abscisse, p3.ordonnee);
    return;
}

type_point milieu (type_point p1, type_point p2) 
{
    type_point m;

    m.abscisse = (p1.abscisse + p2.abscisse)/2;
    m.ordonnee = (p1.ordonnee + p2.ordonnee)/2;
    return m;
}

int main (int argv, char *argc[])
{
    string filename;
    g2_PS_paper paper = g2_Letter;
    g2_PS_orientation orientation = g2_PS_port;
    
    string iFilename;
    string titre;
    double R,G,B;
    type_point S1, S2, S3;

    int orig_x=0;
    int orig_y=0;
    int end_x=128;
    int end_y=128;
    int n = 4;
    
    switch (argv) {
        case 3:
            n = atoi(argc[2]);
        case 2:
            int m = atoi(argc[1]);
            if ( m < 6 && m > 0 ) {
                end_x = (int) pow(2.0, m + 6);
                end_y = (int) pow(2.0, m + 6);
            }
            break;
        default: cout << "Pas de modification." << endl;
    }
    //iFilename = argc[1];
    //filename = iFilename + ".ps";
    //pdID = g2_open_PS(filename.c_str(), paper, orientation);
    //pdID = g2_open_EPSF(filename.c_str());

    cout << "Parametres : " << endl 
         << " taille : " << end_x << "x" << end_y << endl
         << " profondeur : " << n << endl ;
    
    pdID = g2_open_X11( end_x-orig_x, end_y-orig_y );


    R = 0;
    G = 0;
    B = 0;
    g2_pen(pdID,g2_ink(pdID,R,G,B));
    g2_filled_rectangle(pdID, orig_x, 
                              orig_y,
                              end_x, 
                              end_y);

    R = 0,1;
    G = 0.1;
    B = 1;
    g2_pen(pdID,g2_ink(pdID,R,G,B));
    S1.abscisse = orig_x;
    S1.ordonnee = orig_y;
    S2.abscisse = end_x;
    S2.ordonnee = S1.ordonnee;
    S3.abscisse = (S1.abscisse + S2.abscisse)/2;
    S3.ordonnee = end_y;

    dessinerPanier(S1, S2, S3, n);

    char c;
    cin.get(c);
    //g2_close(pdID);
    
    return 0;
}
